/*
 * JBoss, Home of Professional Open Source
 * Copyright , Red Hat, Inc. and individual contributors
 * by the @authors tag. See the copyright.txt in the distribution for a
 * full listing of individual contributors.
 *
 * This is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation; either version 2.1 of
 * the License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this software; if not, write to the Free
 * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA, or see the FSF site: http://www.fsf.org.
 */
package org.richfaces.component;

import javax.annotation.Generated;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collection;
import java.util.Collections;
import java.util.List;

import javax.faces.context.FacesContext;
import javax.faces.component.UIComponent;
import javax.faces.component.behavior.ClientBehaviorHolder;
import javax.el.MethodExpression;
import javax.el.ValueExpression;
import javax.faces.component.StateHelper;
import org.richfaces.component.AbstractDragIndicator;

/**
 *  <p>
     The &lt;rich:dragIndicator&gt; component defines a graphical element to display under the mouse cursor during a
     drag-and-drop operation.
 </p>
 @author abelevich

 **/
@Generated({"RichFaces CDK", "4.3.1.Final-redhat-1"})
public class UIDragIndicator extends AbstractDragIndicator
        {

    public static final String COMPONENT_TYPE="org.richfaces.DragIndicator";

    public static final String COMPONENT_FAMILY="org.richfaces.DragIndicator";

    @Override
    public String getFamily() {
        return COMPONENT_FAMILY;
    }

    public UIDragIndicator() {
        super();
        setRendererType("org.richfaces.DragIndicatorRenderer");
    }




    protected enum Properties {
        acceptClass,
        draggingClass,
        rejectClass
        
    }

 
    public String getAcceptClass() {
        String value = (String) getStateHelper().eval(Properties.acceptClass);
        return value;
    }
    
    public void setAcceptClass(String acceptClass) {
        getStateHelper().put(Properties.acceptClass, acceptClass);
    }

 
    public String getDraggingClass() {
        String value = (String) getStateHelper().eval(Properties.draggingClass);
        return value;
    }
    
    public void setDraggingClass(String draggingClass) {
        getStateHelper().put(Properties.draggingClass, draggingClass);
    }

 
    public String getRejectClass() {
        String value = (String) getStateHelper().eval(Properties.rejectClass);
        return value;
    }
    
    public void setRejectClass(String rejectClass) {
        getStateHelper().put(Properties.rejectClass, rejectClass);
    }

    

}
