/*
 * JBoss, Home of Professional Open Source
 * Copyright , Red Hat, Inc. and individual contributors
 * by the @authors tag. See the copyright.txt in the distribution for a
 * full listing of individual contributors.
 *
 * This is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation; either version 2.1 of
 * the License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this software; if not, write to the Free
 * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA, or see the FSF site: http://www.fsf.org.
 */
package org.richfaces.ui.output.component;

import javax.annotation.Generated;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collection;
import java.util.Collections;
import java.util.List;

import javax.faces.context.FacesContext;
import javax.faces.component.UIComponent;
import javax.faces.component.behavior.ClientBehaviorHolder;
import javax.el.MethodExpression;
import javax.el.ValueExpression;
import javax.faces.component.StateHelper;
import org.richfaces.component.AbstractChartPoint;
import org.richfaces.component.AxisAttributes;

/**
 *  The &lt;rich:chartPoint&gt; tag defines the value of point. It is supposed to be used
 inside the &lt;r:series&lt; tag.
 @author Lukas Macko

 **/
@Generated({"RichFaces CDK", "4.3.1.Final-redhat-1"})
public class UIPoint extends AbstractChartPoint
    implements AxisAttributes    {

    public static final String COMPONENT_TYPE="org.richfaces.ui.output.Point";

    public static final String COMPONENT_FAMILY="org.richfaces.ui.output.ChartFamily";

    @Override
    public String getFamily() {
        return COMPONENT_FAMILY;
    }






    protected enum Properties {
        format,
        label,
        max,
        min,
        pad,
        x,
        y
        
    }

 
    public String getFormat() {
        String value = (String) getStateHelper().eval(Properties.format);
        return value;
    }
    
    public void setFormat(String format) {
        getStateHelper().put(Properties.format, format);
    }

 
    public String getLabel() {
        String value = (String) getStateHelper().eval(Properties.label);
        return value;
    }
    
    public void setLabel(String label) {
        getStateHelper().put(Properties.label, label);
    }

 
    public String getMax() {
        String value = (String) getStateHelper().eval(Properties.max);
        return value;
    }
    
    public void setMax(String max) {
        getStateHelper().put(Properties.max, max);
    }

 
    public String getMin() {
        String value = (String) getStateHelper().eval(Properties.min);
        return value;
    }
    
    public void setMin(String min) {
        getStateHelper().put(Properties.min, min);
    }

 
    public Double getPad() {
        Double value = (Double) getStateHelper().eval(Properties.pad);
        return value;
    }
    
    public void setPad(Double pad) {
        getStateHelper().put(Properties.pad, pad);
    }

 
    public Object getX() {
        Object value = (Object) getStateHelper().eval(Properties.x);
        return value;
    }
    
    public void setX(Object x) {
        getStateHelper().put(Properties.x, x);
    }

 
    public Object getY() {
        Object value = (Object) getStateHelper().eval(Properties.y);
        return value;
    }
    
    public void setY(Object y) {
        getStateHelper().put(Properties.y, y);
    }

    

}
